LeetCode 162. 寻找峰值(二分)

文章目录

LeetCode、162. 寻找峰值【中等,最大值、二分】

来源:LeetCode专题《LeetCode 75》

题目及类型

题目地址:LeetCode、162. 寻找峰值

题目类型:基础算法/二分

题目描述:给定一个长度为n的数组nums,请你找到峰值并返回其索引。数组可能包含多个峰值,在这种情况下,返回任何一个所在位置即可。

1.峰值元素是指其值严格大于左右相邻值的元素。严格大于即不能有等于
2.假设 nums[-1] = nums[n] = -\infty−∞
3.对于所有有效的 i 都有 nums[i] != nums[i + 1]
4.你可以使用O(logN)的时间复杂度实现此问题吗?

思路及代码

思路1:二分

思路说明:拆分范围

由于题目假设 nums[-1] = nums[n] = -∞ ,那么我们一定能够找到一个峰值元素。

  • nums[mid] > nums[mid + 1] [l, mid]
  • nums[mid] < nums[mid + 1] [mid + 1, r]

由于没有r = mid - 1情况,那么我们无需进行(l + r + 1) / 2

复杂度分析:

  • 时间复杂度:O(logn)
  • 空间复杂度:O(1)

image-20240119215046211

class Solution {

    //二分
    //元素值是int最大值
    //边界值无需处理
    //nums[mid] > nums[mid + 1]  [l, mid]     nums[mid] < nums[mid + 1] [mid + 1, r]
    public int findPeakElement(int[] nums) {
        int l = 0, r = nums.length - 1;
        while (l < r) {
            int mid = l + r >> 1;
            if (nums[mid] > nums[mid + 1]) {
                r = mid;
            }else {
                l = mid + 1;
            }
        }
        return l;
    }
}

思路2:寻找最大值

复杂度分析:时间复杂度O(n),空间复杂度O(1)

class Solution {

    //找到最大值索引
    public int findPeakElement(int[] nums) {
        int max = 0; 
        for (int i = 1; i < nums.length; i ++) {
            if (nums[max] < nums[i]) {
                max = i;
            }
        }
        return max;
    }
}

image-20240119215549385


整理者:长路 整理时间:2024.1.19

评论区请在客户端页面查看